#include<bits/stdc++.h>
using namespace std;
int t,c;
int n,k,u,v,num,head[110000],ei[110000];
struct Edge{
	int u,v,nxt;
}e[110000];
void add(int u,int v)
{
	e[++num].u=u;
	e[num].v=v;
	e[num].nxt=head[u];
	head[u]=num;
}
int main()
{
	freopen("traverse.in","r",stdin);
	freopen("traverse.out","w",stdout);
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin>>c>>t;
	while(t--)
	{
		num=0;
		
		cin>>n>>k;
		for(int i=1;i<n;i++)
		{
			cin>>u>>v;
			add(u,v);
		}
		for(int i=1;i<=k;i++)
		{
			cin>>ei[i];
		}
		if(c==18)
		{
			puts("1");
			continue;
		}
	}
	return 0;
}

